C      PROGRAM  SIMTARMA: SETARMA MODEL SIMULATION

      PARAMETER(MOB=15500, MK=20, MP=36, MQ=36)
      IMPLICIT REAL*8 (A -H , O - Z)
      CHARACTER*72  FNAME, FMT, PNAME
      DIMENSION Z(MOB),ETILDA(MOB),R(MK),PPA(MK, MP),QQA(MK, MQ),C(MK)
     +,           nnp(mk), nnq(mk)
      COMMON /RAND/ IX, IY, IZ

C   THIS ROUTINE GENERATES NSCART+NOB OBSERVATIONS, NSCART ARE DISCARDED
C   AND NOB ARE STORED INTO THE FILE FNAME WITH FORMAT FMT
C   MODEL IS A FULL THRESHOLD ARMA WITH ORDERS NP AND NQ RESPECTIVELY
C   MODEL CONSTANT IS ALWAYS INCLUDED IN EACH REGIME  
C   THE NUMBER OF REGIMES IS k, THE THRESHOLD PARAMETERS ARE r(1)..r(k1)
C   (k1=k-1) THE DELAY PARAMETER IS nd,  THE ERROR VARIANCE IS VARE
   
      OPEN(UNIT=1,FILE='simtarma.txt')
      READ(1,*) NOB, NSCART, k, k1, nd
      if(k1  .ge.  1) read(1,*) (r(i),i=1,k1)
      DO  1 I  =1 , K
      READ(1 , *)  C(I)
      READ(1 , *)  nnp(i)
      np = nnp(i)
      IF(NP.GT.0)  READ(1,*) (PPA(I , J), J=1 , NP)
      READ(1 , *)  nnq(i)
      nq =  nnq(i)
      IF(NQ.GT.0)  READ(1,*) (QQA(I , J), J=1 , NQ)
1     CONTINUE
      READ(1,*)  VARE
      READ(1,*) IX, IY, IZ
      READ(1,110) FNAME
      READ(1,110) FMT
      READ(1,110) PNAME
110   FORMAT(A72)
      CLOSE(UNIT=1)

      write(*,*) 'fine lettura parametri modello SETARMA'
      pause

      LPRINT  = 6

      OPEN(UNIT= LPRINT, FILE = PNAME)
      WRITE(LPRINT, 101) NOB, NSCART, k, k1, nd
101   FORMAT(1H  ,'NOB,NSCART,k,k1,nd '  , I6, I6, I3, I3, I3)
      WRITE(LPRINT, 102) 
102   FORMAT(1H  ,'Threshold parameters')
      WRITE(LPRINT, 100) (r(i),i=1,k1)
100   FORMAT(1H  ,10F7.4)
      WRITE(LPRINT, 107) IX, IY, IZ
107   FORMAT(1H  ,'SEEDS IX IY IZ ', 3I10)

      NSCAR1 = NSCART + 1
      NTOT = NSCART + NOB 
      DO  4401  I  =  1  ,  NTOT
4402   PPX0 =  RANDOM(L)
      PPX1 =  PPND16(PPX0 , IZAULT)
      IF(IZAULT .NE. 0)  GOTO  4402
4401   ETILDA(I) =  PPX1 * DSQRT(VARE)   

       sse = 0D0
       do 41401 i = nscar1, ntot
41401   sse  =  sse  +  etilda(i) ** 2
       vsse  =  sse/ dble(nob)

      write(lprint,  55668) nscar1, ntot
55668 format(1h  ,'nscart+1, nscart+nob = ', 2I10)
       write(lprint, 91)  nob, vare, vsse
91     format(1h  ,'Error var nob,true,esti ',I10,2D12.4) 
      WRITE(LPRINT, 103) 
103   FORMAT(1H  ,'Setarma model ')
      DO  10  II  =1  ,  K
      WRITE(LPRINT, 104) II,  C(II)
104   FORMAT(1H   ,'Regime,constant ', I6, D16.5)
      NP = NNP(II)
      WRITE(LPRINT, 105) NP
105   FORMAT(1H  ,'AR PARAMETERS, BOX-JENKINS NOTATION: NP ', I5)
      WRITE(LPRINT, 100) (PPA(II,J) , J=1, NP)
      NQ = NNQ(II)
      WRITE(LPRINT, 106)  NQ
106   FORMAT(1H  ,'MA PARAMETERS, BOX-JENKINS NOTATION: NQ ', I5)
      WRITE(LPRINT, 100) (QQA(II,J) , J=1, NQ)
10    CONTINUE
      WRITE(LPRINT, 108)
108   FORMAT(1H  ,'FILES: DATA OUTPUT, FORMAT, PRINT')
      WRITE(LPRINT,110) FNAME
      WRITE(LPRINT,110) FMT
      WRITE(LPRINT,110) PNAME

       CLOSE(UNIT = LPRINT)
  
C       WHITE NOISE FROM 1 TO NM=MAX(ND,NP,NQ)

        NM = MAX0(ND, MAX0(NP,NQ))
        DO  2 I =1 , NM
2       Z(I)   =  ETILDA(I)

C       SETARMA MODEL FROM NM+1 TO NTOT

      NM1 =  NM+ 1
      DO  3  I = NM1 , NTOT

C       FIND THE REGIME FOR OBSERVATION I
c        write(*,*) i,z(i-nd)
c        pause
      IF(Z(I-ND) .LE.  R(1)) THEN 
      II =  1
      ENDIF
      IF(K1 .GE. 2) THEN
      DO  4  IJ = 2 , K1
      IF(Z(I-ND) .GT. R(IJ-1) .AND. Z(I-ND) .LE. R(IJ)) GOTO  5
4     CONTINUE
5     II=  IJ
      ENDIF
      IF(Z(I-ND) .GT. R(K1)) THEN
      II  =  K
      ENDIF
c        write(*,*) 'regime ' , ii
c        pause

C       SET ARMA MODEL IN REGIME II FOR OBSERVATION I 

      Z(I) = ETILDA(I) + C(II)
c      write(*,*) 'c,e,z ', c(ii), etilda(i), z(i)
      NP =  NNP(II)
      IF(NP .GT. 0)  THEN
      DO  6   J =  1  , NP
      Z(I) = Z(I) + PPA(II, J) * Z(I - J)
c      write(*,*) 'j,phi(j),z(i-j),z ',j,ppa(ii,j),z(i-j),z(i)
6     CONTINUE
      ENDIF
      NQ =  NNQ(II)
      IF(NQ .GT. 0)  THEN
      DO  8   J =  1  , NQ
      Z(I) = Z(I) - QQA(II, J) * ETILDA(I - J)
c      write(*,*) 'j,theta(j),e(i-j),z ',j,qqa(ii,j),etilda(i-j),z(i)
8     CONTINUE
      ENDIF
3     CONTINUE

      write(*,*) 'fine simulazione modello SETARMA'
      pause

C       RECORD THE LAST NOB OBSERVATIONS IN FILE FNAME WITH FORMAT FMT	       

      OPEN(UNIT =10, FILE = FNAME)
       write(*,*) 'nscar1, ntot ', nscar1 , ntot
      DO 7 I = NSCAR1, NTOT
7     WRITE(10, FMT)  Z(I)
      CLOSE(UNIT = 10)

      STOP
      END


      REAL*8 function  random(l)

c        algorithm as 183 Appl. Statist. (1982) Vol. 31, no. 2
c
c        returns a pseudo-random number rectangularly distributed 
c        between  0  and 1.
c
c        ix, iy and iz should be set to integer values between 
c        1 and 30000 before first entry
c
c        integer arithmetic up to 30323  is required

      IMPLICIT REAL*8 (A -H , O - Z)
	common /rand/  ix, iy,  iz
	ix = 171 * mod(ix, 177) - 2 * (ix / 177)
	iy = 172 * mod(iy, 176) - 35 * (iy / 176)
	iz = 170 * mod(iz, 178) - 63 * (iz / 178)

	if (ix .lt. 0) ix = ix + 30269
	if (iy .lt. 0) iy = iy + 30307
	if (iz .lt. 0) iz = iz + 30323

c        if integer arithmetic up to 5212632 is available, 
c        the preceding 6 statements may be replaced by
c
c        ix = mod(171 * ix, 30269)
c        iy = mod(172 * iy, 30307) 
c        iz = mod(170 * iz, 30323)
c
c        on some machines, this may slightly increase
c        the speed. the results will be identical.

	random  = DMOD(DBLE(ix) / 30269D0 + DBLE(iy) / 30307D0 +
     *                 DBLE(iz) / 30323D0, 1D0)

	return
	end


        DOUBLE PRECISION FUNCTION PPND16 (P, IFAULT)
C
C       ALGORITHM AS241  APPL. STATIST. (1988) VOL. 37, NO. 3
C
C       Produces the normal deviate Z corresponding to a given lower
C       tail area of P; Z is accurate to about 1 part in 10**16.
C
C       The hash sums below are the sums of the mantissas of the
C       coefficients.   They are included for use in checking
C       transcription.
C
        DOUBLE PRECISION ZERO, ONE, HALF, SPLIT1, SPLIT2, CONST1,
     *          CONST2, A0, A1, A2, A3, A4, A5, A6, A7, B1, B2, B3,
     *          B4, B5, B6, B7,
     *          C0, C1, C2, C3, C4, C5, C6, C7, D1, D2, D3, D4, D5,
     *          D6, D7, E0, E1, E2, E3, E4, E5, E6, E7, F1, F2, F3,
     *          F4, F5, F6, F7, P, Q, R
        PARAMETER (ZERO = 0.D0, ONE = 1.D0, HALF = 0.5D0,
     *          SPLIT1 = 0.425D0, SPLIT2 = 5.D0,
     *          CONST1 = 0.180625D0, CONST2 = 1.6D0)
C
C       Coefficients for P close to 0.5
C
        PARAMETER (A0 = 3.38713 28727 96366 6080D0,
     *             A1 = 1.33141 66789 17843 7745D+2,
     *             A2 = 1.97159 09503 06551 4427D+3,
     *             A3 = 1.37316 93765 50946 1125D+4,
     *             A4 = 4.59219 53931 54987 1457D+4,
     *             A5 = 6.72657 70927 00870 0853D+4,
     *             A6 = 3.34305 75583 58812 8105D+4,
     *             A7 = 2.50908 09287 30122 6727D+3,
     *             B1 = 4.23133 30701 60091 1252D+1,
     *             B2 = 6.87187 00749 20579 0830D+2,
     *             B3 = 5.39419 60214 24751 1077D+3,
     *             B4 = 2.12137 94301 58659 5867D+4,
     *             B5 = 3.93078 95800 09271 0610D+4,
     *             B6 = 2.87290 85735 72194 2674D+4,
     *             B7 = 5.22649 52788 52854 5610D+3)
C       HASH SUM AB    55.88319 28806 14901 4439
C
C       Coefficients for P not close to 0, 0.5 or 1.
C
        PARAMETER (C0 = 1.42343 71107 49683 57734D0,
     *             C1 = 4.63033 78461 56545 29590D0,
     *             C2 = 5.76949 72214 60691 40550D0,
     *             C3 = 3.64784 83247 63204 60504D0,
     *             C4 = 1.27045 82524 52368 38258D0,
     *             C5 = 2.41780 72517 74506 11770D-1,
     *             C6 = 2.27238 44989 26918 45833D-2,
     *             C7 = 7.74545 01427 83414 07640D-4,
     *             D1 = 2.05319 16266 37758 82187D0,
     *             D2 = 1.67638 48301 83803 84940D0,
     *             D3 = 6.89767 33498 51000 04550D-1,
     *             D4 = 1.48103 97642 74800 74590D-1,
     *             D5 = 1.51986 66563 61645 71966D-2,
     *             D6 = 5.47593 80849 95344 94600D-4,
     *             D7 = 1.05075 00716 44416 84324D-9)
C       HASH SUM CD    49.33206 50330 16102 89036
C
C       Coefficients for P near 0 or 1.
C
        PARAMETER (E0 = 6.65790 46435 01103 77720D0,
     *             E1 = 5.46378 49111 64114 36990D0,
     *             E2 = 1.78482 65399 17291 33580D0,
     *             E3 = 2.96560 57182 85048 91230D-1,
     *             E4 = 2.65321 89526 57612 30930D-2,
     *             E5 = 1.24266 09473 88078 43860D-3,
     *             E6 = 2.71155 55687 43487 57815D-5,
     *             E7 = 2.01033 43992 92288 13265D-7,
     *             F1 = 5.99832 20655 58879 37690D-1,
     *             F2 = 1.36929 88092 27358 05310D-1,
     *             F3 = 1.48753 61290 85061 48525D-2,
     *             F4 = 7.86869 13114 56132 59100D-4,
     *             F5 = 1.84631 83175 10054 68180D-5,
     *             F6 = 1.42151 17583 16445 88870D-7,
     *             F7 = 2.04426 31033 89939 78564D-15)
C       HASH SUM EF    47.52583 31754 92896 71629
C
        IFAULT = 0
        Q = P - HALF
        IF (ABS(Q) .LE. SPLIT1) THEN
          R = CONST1 - Q * Q
          PPND16 = Q * (((((((A7 * R + A6) * R + A5) * R + A4) * R + A3)
     *                  * R + A2) * R + A1) * R + A0) /
     *                (((((((B7 * R + B6) * R + B5) * R + B4) * R + B3)
     *                  * R + B2) * R + B1) * R + ONE)
          RETURN
        ELSE
          IF (Q .LT. ZERO) THEN
            R = P
          ELSE
            R = ONE - P
          END IF
          IF (R .LE. ZERO) THEN
            IFAULT = 1
            PPND16 = ZERO
            RETURN
          END IF
          R = SQRT(-LOG(R))
          IF (R .LE. SPLIT2) THEN
            R = R - CONST2
            PPND16 = (((((((C7 * R + C6) * R + C5) * R + C4) * R + C3)
     *                  * R + C2) * R + C1) * R + C0) /
     *               (((((((D7 * R + D6) * R + D5) * R + D4) * R + D3)
     *                  * R + D2) * R + D1) * R + ONE)
          ELSE
            R = R - SPLIT2
            PPND16 = (((((((E7 * R + E6) * R + E5) * R + E4) * R + E3)
     *                  * R + E2) * R + E1) * R + E0) /
     *               (((((((F7 * R + F6) * R + F5) * R + F4) * R + F3)
     *                  * R + F2) * R + F1) * R + ONE)
          END IF
          IF (Q .LT. ZERO) PPND16 = - PPND16
          RETURN
        END IF
        END

