C     PROGRAM XGATAR: DRIVER ROUTINE GATAR FOR THE ESTIMATION OF THE
C     k-REGIMES THRESHOLD AUTOREGRESSIVE MODEL (d, p1, ..., pk)
C     THE GENETIC ALGORITHM FINDS BOTH k AND THRESHOLD CONSTANTS r1..rk1
C     INPUT DATA TIME SERIES Z WITH NOB OBSERVATIONS IN COMMON /TSOBS/
                                                                        
      PARAMETER(MOB=5500, MP= 30, MP1= MP+1, MK= 10, nmx= 100, mlagh=36)
      IMPLICIT REAL*8(A - H , O - Z)
      CHARACTER*72  FNAME, PNAME
      dimension NO(nmx, mob), NN(nmx, mob), lbest(mob), lchrom(mob)
     +, lchro1(mob), lchro2(mob)
      dimension  Y(mob), RES(mob), VFIT(mob), RHO(mlagh), COV(mlagh)
     +, PA(MP1), fz(mob), fitx(mob), fity(mob), kkn(mob), kng(mob)
     +, nnhp(MK)
      COMMON/TSOBS/ NHB, Z(5500), KKHN(5500), ZO(5500), ZH(5500)
     +, NJ(10), XMAT(5500, 31)
     +, PHI(31), AUX1(31), VC1(31 , 31), BB(31), CC(31), IP(31), IQ(31)                                     
      COMMON/THAR/ icri, np, k, k1, nd, r(10), nnp(10), ppa(10,31)                                     

C     k = no. of regimes, k1 = k-1 = no. of threshold constants r(.)
C
C             1                2               ...             k     
C     _________________|_________________|____ ...  ____|_______________
C                     r(1)              r(2)           r(k-1)
C      z(t-d) < r(1)    r(1)<=z(t-d)<r(2)               z(t-d) >= r(k-1)
C
C     icri = 1 Akaike's AIC criterion; icri = 2 Schwartz's BIC criterion
C  Akaike, H. (1974) A new look at the statistical model identification,
C     IEEE Trans. Automatic Control, AC-19, 716-723, 1974.
C  Schwartz, G. (1978) Estimating the dimension of a model, Ann.Statist.
C     6, 461-464, 1978.

      data  tol/ 8.43D-37/
      IMODEL =  4
      LPRINT  =  6

      OPEN(UNIT=5, FILE='xgatar.txt')
      READ(5,*)   NOB, NAC, mspan, NP, NK, ND, icri
      READ(5, *)  nl, p2, p1, maxit, iseme
      read(5,*)   iprint
      read(5 , 470)      fname
      read(5 , 470)      pname
470    format(A72) 
       close(unit  =  5)
      OPEN(UNIT=10, FILE=fname)
      do  469   i  =1  ,  nob
469   read(10,*)  Y(i)
      close(unit = 10) 

       open(unit= LPRINT, file=pname)

       write(LPRINT  ,  200)  
200    format(1h  ,  'XGATAR.FOR (mainpgm) Maggio 2002'
     +/1h ,'GA estimate of k-regimes TAR model')
      WRITE(LPRINT, 204) NOB, NAC, mspan, NP, NK, ND, icri
204   FORMAT(1H ,'NOB,NAC,mspan,NP,NK,ND,icri= ', 7I7)
      write(lprint, 210) nl, p2, p1, maxit, iseme
210   format(1h ,'nl,p2,p1,maxit,iseme= ', i5, F7.2, F7.3, I10, I10)
       write(LPRINT , 273)  
273    format(1h , 'data input file')
       write(LPRINT , 275)      fname
       write(LPRINT , 274)  
274    format(1h , 'data printout file')
       write(LPRINT , 275)      pname
275    format(1h  ,  A72)
      write(lprint, 10027) iprint
10027 format(1h  ,'stampa serie originale e stimata iprint ', I6)
      WRITE(LPRINT, 309)
309   FORMAT(1H  ,'//')

      CALL ZCOR(Y,NOB,NAC,RHO,COV,DM,DSD,IEXIT)                     
       DO  33881 I  = 1  ,  NOB
33881  FZ(I)  =  Y(I)
        CALL GRADU(FZ,FITX,FITY,KKN,KNG,NOB)
c        NBEST  =   KNG(N)
c        FBEST   =   FZ(NBEST)
c        NWOST  =  KNG(1)
c        FWOST  =   FZ(NWOST)
       DO  33888 I  = 1  ,  NOB
33888  KKHN(I)  =  KNG(I)

      WRITE(LPRINT,  187) IEXIT
187   FORMAT(1H ,'Time series Y statistics ZCOR : IEXIT ', I5)
      write(LPRINT, 207) dm, cov(1), dsd 
207   format(1h  ,'Input data mean, var, sqm =', 3D12.4)
      write(LPRINT, 208) 
208   format(1h ,'Autocorrelation function')
       nac1  =  nac +  1
      write(LPRINT, 203) (rho(j), j=1, nac1)
203    format(1h  , 7f10.4)
c      write(lprint, 218) 
c218   format(1h  ,'time series values, ordered values, kkn, kkg')
c       do  72881  i  =1  ,  nob
c72881 write(lprint, 219) i, fz(i), fity(i), kkn(i), kng(i)
c219    format(1h   ,I10, 2F12.4, 2I10)
c      write(LPRINT, 608) 
c608   format(1h ,'Labels vector of observations in increasing ord KKHN')
c      write(LPRINT, 603) (kkhn(j), j=1, nob)
c603    format(1h  , 10I7)
      write(lprint, 129) 
129    format(1h    ,'//'  )

C    k-REGIMES THRESHOLD AUTOREGRESSIVE MODEL (d, p1, ..., pk) ESTIMATE
C     THE GENETIC ALGORITHM FINDS BOTH k AND THRESHOLD CONSTANTS r1..rk

      SSQL  =  cov(1) * dble(nob)
      nyp  =  np
      nyp1  =  nyp +  1
      DO  38871 I =1  , nyp1
38871 PA(I)  =  0D0
      do  38872  i =  1,  nk
      nnhp(i)  =  nyp
38872 nnp(i)  =  nyp
      NCHRO =  NOB
      NHB  =   NOB
      nhd  =   nd
      do  38727  i  =1  ,  nhb
38727 z(i)  =   y(i)

c      write(lprint, 46116) 
c46116 format(1h  ,'original data y -> z')
c      do  46117  i  =  1  ,  nob
c46117 write(lprint, 49118)  y(i)  , z(i)

      CALL  GATAR(no, nn, nmx, nl, nob, nchro, lbest, lchro1, lchro2
     +, lchrom, nnhp, fbest, ssq, p2, p1, maxit, nk, mspan, nhd, iter2
     +, iseme, lprint, iexit)   

      WRITE(LPRINT,  56187) IEXIT
56187 FORMAT(1H ,'Exit genetic algorithm GATAR : IEXIT ', I5)

      CALL  RESID(Y , NOB, PA , NYP1, RES, VFIT, SSQ, IEXIT, imodel)

      WRITE(LPRINT,  51187) IEXIT
51187 FORMAT(1H ,'Estim model resid sum of square : IEXIT ', I5)

      WRITE(LPRINT , 300) 
300   FORMAT(1H  ,'EXIT GATAR : PARAMETER ESTIMATES ')
      write(lprint, 113)  k
113   format(1h   ,'No. of regimes k = ', I5)
       i1  =  1
      do  9  ii  =  1  ,  k
      nnp1 = nnp(ii)  +  1
       i2  =  nj(ii)
       ik  =  0
       do  10  i  =  i1 ,  i2
       j  = kkhn(i)  +  nd
       if(j .lt.  nnp1  .or.  j .gt.  nob)  goto  10
       ik =  ik  +  1
10     continue
      if(ii .lt.  k)  then
      write(lprint, 110) ii, r(ii), nnp(ii), ik
110   format(1h   ,'regime,r,p,obs. ', I5, F12.4, I6, I10)
      else 
      write(lprint, 114) ii,  nnp(ii),  ik
114   format(1h   ,'regime,.,p,obs. ', I5, 12X , I6, I10)
      endif
      write(lprint, 111) (ppa(ii, jj),  jj=1 , nnp1)
111 	format(1h  ,7F10.4)
       i1  =  i2 + 1
9     continue
      WRITE(LPRINT,  308)  SSQL
308   FORMAT(1H  ,'OBSERVATIONS SUM OF SQUARES SSQL = ', D14.6)
      WRITE(LPRINT,  304)  SSQ
304   FORMAT(1H  ,'RESIDUAL SUM OF SQUARES SSQ = ', D14.6)
      resvar = SSQ / dble(nob) 
      WRITE(LPRINT,  305) resvar 
305   FORMAT(1H  ,'RESIDUAL variance = ', D14.6)
      ntp  =  0
      do  19  i =  1  , k
19    ntp =  ntp + nnp(i) + 1
      write(lprint, 306) ntp
306   format(1h   ,'Total number of AR parameter ntp = ', I5) 
      if(icri  .eq.  1)  then
      py  =  dble(ntp) * 2D0 
      crh = dble(nob)*dlog(dabs(resvar)) + dble(ntp) * 2D0 
      else
      py =  dble(ntp) * dlog(dble(nob)) 
      crh =dble(nob)*dlog(dabs(resvar)) + dble(ntp) * dlog(dble(nob)) 
      endif
      xlns = 	dlog(dabs(resvar))
      write(lprint, 307)  xlns, py, crh, crh/dble(nob)
307   format(1h  ,'Ln(sigma2) = ', D14.6, 5x, 'Penalty = ', D14.6
     +/1h   ,'Criterion = ', D14.6/1h   ,'pooled NAIC = ',D14.6 )
       if(iprint  .eq.  1)  then
      write(lprint, 40117) 
40117 format(1h  ,'original data , fitted values, residuals')
      do  49117  i  =  1  ,  nob
      rgrty  =   y(i) -  vfit(i)
49117 write(lprint, 49118)  y(i), vfit(i), rgrty
49118 format(3F20.10)
       endif
      WRITE(LPRINT, 309)

      CLOSE(UNIT=LPRINT)
      STOP
      END


      SUBROUTINE GATAR(no, nn, nmx, nl, nob, nchro, lbest, lchro1,lchro2
     +, lchrom, nnhp, fbest, ssq, p2, p1, maxit, nk, mspan, nhd, iter2
     +, iseme, lprint, iexit)
      IMPLICIT REAL*8(A - H , O - Z)
      dimension  NO(nmx, nchro), NN(nmx, nchro), lbest(nchro)
     +,lchrom(nchro), lchro1(nchro), lchro2(nchro), nnhp(nk)
     +, FITCUM(nl), FITN(nl)
      data  zero /0.0D-000/
	data small , big / 8.43D-37, 3.37D+38/
        data  tol  /8.43D-37/ 

C       Initializations

       DO 99399   I   =   1  ,  NL
       DO 99399    J   =    1  ,   NCHRO
       NO(I   ,   J)   =  0
99399     NN(I  ,   J)  =   0
        DO 99398  I  =   1  ,  NCHRO
99398   LBEST(I)   =   0
        DO 99397  I  =   1  ,  NCHRO
        lchro1(I)   =   0
99397     lchro2(I)   =   0
       DO 99396  I  =  1,  NL
        FITCUM(I)= zero
99396    FITN(I)  =   zero

C       Initial population, no more than nk one's are allowed, zeroes
C       must be in genes 1..nq1 and nob-nq1+1..nob

       nq1 = nhd
        do  33441 i=1  ,  nk
       if(nnhp(i). gt. nq1) nq1 =  nnhp(i)
33441     continue
        npd  =  nq1
        nk1  =  nk - 1
        do  33442  i  =1  ,  nl
        call  vsunif(iseme, ris)
      nk2 =  max0(1, min0(nk1, idnint(-5D-1 + ris * (dble(nk1) + 1D0)))) 
33449   continue
        DO 96997  II  =   1  ,  NCHRO
96997    no(i , ii)    =   0
      do  33443  j  =  1  ,  nk2
        call  vsunif(iseme, ris)
      ij = max0(npd + 1, min0(nob - npd
     +, idnint(dble(npd + 1) + ris*(dble(nob - npd) - dble(npd + 1)))))
33443  no(i , ij)  =   1
        DO 99997  II  =   1  ,  NCHRO
99997  lchrom(II)   =   no(i , ii)
c       write(*,*) (lchrom(ii), ii=1, nchro)
       call  gcheck(lchrom, nchro, npd, nk, mspan, ixflag)
c       write(*,*)  ixflag
c       pause
        if(ixflag .lt. 0)  goto  33449
33442  continue

      do  33552 ii  =  1  ,  nchro
33552 no(1 , ii)  =   0
      no(1 ,  62)  =  1
c      write(lprint, 190)
c190   format(1h  ,'Initial population')
c      do   33444 i  =1  ,  nl
c33444 write(lprint, 191) (no(i , j), j = 1 , nchro)  
c191   format(1h  ,70I1)

      fbest =  zero
      do 97  k  =  1,  nl
      do 98  i  =  1,  nchro
98    lchrom(i)    =   no(k  ,  i)
      fffit = FFB(lchrom, nchro, nk, lprint, ifault)
       IF(IFAULT .NE. 0) fffit  =  zero
       if(fffit.le.fbest)  goto  90
       fbest  =   fffit
	 nbest  =   k
90      continue
97      continue
	 do  91  i  =   1,  nchro
91      lbest(i)   =    no(nbest  ,  i)
	   fbest1  =   fbest

C       Genetic algorithm loop

         iter  =  0
         iter2    =  0
	 WRITE(*,*)  '     Iterazione ..... '
1234	  continue
         iter  =  iter + 1

	WRITE(*,*)  ITER

C  calcolo della fitness function per ogni individuo, del tot e del max

	FBEST  =  zero
      fwost  =   big
	DO 2000 K = 1 , NL
	 do  2001  i  =  1,  nchro
2001     lchrom(i)   =   no(k , i)
      fffit = FFB(lchrom, nchro, nk, lprint, ifault)
	if (fffit.le.fbest) goto 2043
	fbest  =   fffit
	nbest  =    k
2043     continue
	if (fffit.ge.fwost) goto 2044
	fwost  =   fffit
	nwost  =    k
2044     continue
	FITN(K) = FFFIT
2000    CONTINUE

	  iter1  =  iter  -   1
      if(fbest-fbest1 .gt. tol) write(LPRINT,225) iter1, fbest1 , fbest
225     format(1h ,4x,i10,' : ',f12.5,' -> ',f12.5)
       if(fbest-fbest1 .gt. tol) iter2 =  iter1

C        Strategia elitista

      if(fbest1 .le. fbest)  then
       do  2002  i =1  ,  nchro
2002  lbest(i)  =  no(nbest , i)
       fbest1  =  fbest
      else
       do  2003  i =1  , nchro
2003  no(nwost , i)  =  lbest(i)
       fitn(nwost) =  fbest1
       nbest =  nwost
      fbest  =  fbest1
      endif

	  IF(ITER.gt.MAXIT) GOTO  2100

C   riproduzione della popolazione: SI USA LA TECNICA DELLA FITNESS
C   cumulata  CON M = N         P(t) ---> P*(t+1)

	FFTOT = zero
	DO 22000 K = 1 , NL
       FFFIT =  FITN(K)
	FFTOT = FFTOT + FFFIT
	 FITCUM(K)  =   FFTOT
22000    CONTINUE

          if(fftot .LT. SMALL)    then
          iexit  =  -1
          return
          endif

	  DO  22007  K =  1 ,  NL
22007  FITCUM(K)  =   FITCUM(K)/FFTOT
	  
c      IF(FBEST.GT.tol) THEN
c      ssq  =  1D0 / FBEST
c      ELSE
c      ssq  =  big
c      ENDIF
c      WRITE(LPRINT,  55593)  
c55593  FORMAT(1H  ,'Strategia elitista: best indiv., fitness, ssq ')
c	 WRITE(LPRINT,55500) NBEST, FBEST, ssq
c55500  format(1h  ,I10,  D14.6, D14.6) 
c       write(LPRINT , 5556)  (LBEST(I), I=1,nchro) 
c      WRITE(LPRINT,  55592)
c55592  format(1h   ,'Population ')
c       do 76011  k  =  1  ,   nl
c76011  write(lprint, 54557) (no(k ,  j),  j=1, nchro)
c54557   format(1h   ,70I1)

	DO 3000 K = 1 , NL
        CALL VSUNIF(ISEME, RIS)
       DO 3001  KS  =  1  ,   NL
       IF(RIS.LE.FITCUM(KS))  GOTO 3003
3001    CONTINUE
	 KS  =  NL
3003    DO 3100 I = 1 , nchro
3100    NN(k , i) = NO(ks , i)
3000    CONTINUE

	 DO 3010   K  =  1  ,  NL
	 DO 3010    I  =  1  ,  nchro
3010     NO(k , i)  =  NN(k , i)

c      WRITE(LPRINT,  55594)  
c55594  FORMAT(1H  ,'Riproduzione ')
c       do 76012  k  =  1  ,   nl
c76012  write(lprint, 54557) (no(k , j),  j=1, nchro)

C    calcolo del crossover su una proporz. pari a p2 degli n individui
C     = n*p2 individui ovvero n*p2/2 coppie     P*(t+1) ---> P**(t+1)
c    due diversi cromosomi sono scelti a caso e ricombinati a partire
c     dal punto di taglio aleatorio ltag+1 e fino a ngeni
C     L'intero LTAG e' il piu' vicino a 
c      (1 - 1/2) + (NGENI - 1/2 - 1 + 1/2) * RND(IX,IY,IZ)
C  Nearest integer (Round to integer)= NINT(x) (Arg REAL, Funct INTEGER)

      ncrott  =  idint(p2 * dble(nl) / 2D0)

      DO     30     J  =   1    ,   ncrott

        CALL VSUNIF(ISEME, RIS)
       k1  =  MAX0(1, MIN0(NL, IDnint(5D-1   +   ris * DBLE(nl)))) 
        CALL VSUNIF(ISEME, RIS)
       k2 = MOD(IDNINT(5D-1 + ris*DBLE(nl-1)) + k1 -1, nl) + 1 
        CALL VSUNIF(ISEME, RIS)
      ltag = MAX0(1, MIN0(nchro-1, IDNINT(5D-1 + ris * DBLE(nchro- 1)))) 
	 ltagp1 = ltag +  1

      do  3004  i =1  , nchro
      lchro1(i)  =  no(k1 , i)
3004   lchro2(i) =  no(k2 , i)

c      write(lprint, 54557) (no(k1 , jjjj),  jjjj=1, nchro)
c      write(lprint, 54557) (no(k2 , jjjj),  jjjj=1, nchro)

       DO 55 I = LTAGP1 , nchro
       JGENE = lchro1(i)
       lchro1(i) = lchro2(i)
       lchro2(i)  =  JGENE
55      CONTINUE

C       check if every regime contains mspan observations at least

       call  gcheck(lchro1, nchro, npd, nk, mspan, ixfla1)
       call  gcheck(lchro2, nchro, npd, nk, mspan, ixfla2)
       if(ixfla1.eq.0  .and.  ixfla2.eq.0) then
      do  3005  i =  1  ,  nchro
      no(k1 , i)  =   lchro1(i)
3005  no(k2 , i)  =  lchro2(i)
       endif

c       write(lprint,  13117) j
c13117  format(1h  , 'coppia ',  i5)
c      write(lprint,  13118) k1 , k2, ltag, ltagp1
c13118 format(1h  ,'k1,k2,ltag,ltagp1 ', 4I6)
c      write(lprint,  13119)  ixfla1, ixfla2
c13119 format(1h  ,'ixfla1,ixfla2 ', 2I6)
c      write(lprint, 54557) (no(k1 , jjjj),  jjjj=1, nchro)
c      write(lprint, 54557) (no(k2 , jjjj),  jjjj=1, nchro)

30        continue
	  
c      WRITE(LPRINT,  55595)  
c55595  FORMAT(1H  ,'Crossover ')
c       do 76022  k  =  1  ,   nl
c76022  write(lprint, 54557) (no(k , j),  j=1, nchro)

C        calcolo delle mutazioni: P**(t+1) ---> P***(t+1)

      nppd1  =  npd  +  1
      nppd2  =   nob - npd

	DO  4000   K  =  1 ,  NL

      do  4004  i =1  , nchro
4004   lchrom(i) =  no(k , i)

C       write(lprint, 54557) (lchrom(i),  i=1, nchro)

	DO   4200   I  =  nppd1  ,  nppd2
        CALL VSUNIF(ISEME, RIS)

C       La mutazione ha luogo se RND <= Pm  (Pm=P1)

	IF(RIS.gt.P1) goto  4200
      lchrom(i) =  1  - lchrom(i) 
4200    CONTINUE

C       write(lprint, 54557) (lchrom(i),  i=1, nchro)

C        check  if all regimes contain at least mspan observations

       call  gcheck(lchrom, nchro, npd, nk, mspan, ixflah)

c       write(lprint,  30301) ixflah
c30301  format(1h  ,  'ixflah = ', I5)

       if(ixflah.eq.0) then
      do  4005  i =  1  ,  nchro
4005  no(k , i)  =  lchrom(i)
       endif

4000    CONTINUE

c      WRITE(LPRINT,  55596)  
c55596  FORMAT(1H  ,'Mutazione ')
c       do 76044  k  =  1  ,   nl
c76044  write(lprint, 54557) (no(k , j),  j=1, nchro)

	GOTO  1234

C         end   iterations

2100    CONTINUE

      fffit = FFB(lbest, nchro, nk, lprint, ifault)
c      IF(fffit.GT.tol) THEN
c      ssq = 1D0 / fffit
c      ELSE
c      ssq  = BIG
c      ENDIF
      IF(fffit.GT.tol) THEN
      ssq = -dlog(fffit)
      ELSE
      ssq  = BIG
      ENDIF
       
	     iter1  =  iter  - 1
	     write(LPRINT ,  55570)  iter1, ITER2
55570   format(1x/4x,'End genetic algorithm : iter, iter2 = ', 2i10)
	  WRITE(LPRINT,5557)   NBEST  , FBEST
5557     FORMAT(1X,4X,'Migliore cromosoma ',I4,2X,'Fitn.Funct.',E12.5)
	WRITE(LPRINT,5556)(lbest(i), I=1,nchro)
5556    format(1h   ,70I1)
c	     write(LPRINT ,  10009)  fffit, ssq
c10009     format(1h  ,'fitness, ssq ', 2D15.6)
	     write(LPRINT ,  10009)  fffit, ssq
10009     format(1h  ,'fitness, criterion ', 2D15.6)

       RETURN

        END


      subroutine  gcheck(lchrom, nchro, npd, nk, mspan, ifault)

C       gcheck controlla che per ciascun regime vi siano almeno mspan 
C       osservazioni; gli errori possibili sono:
C       ifault = -1: tra la coda iniziale e finale non ci sono istanti
C       ifault = -2: almeno un regime ha meno di mspan osservazioni
C       ifault = -3: il cromosoma codifica piu' regimi del massimo nk
 
      dimension   lchrom(nchro)
      ifault  =  0
      npd1  =  npd +  1
      npd2  =  nchro - npd
      if(npd2  .lt.  npd1)  then
      ifault  =  -1
      return
      endif
      i1  = 0
      ic  =  0
      do  1   i  =  npd1  , npd2
      if(lchrom(i) .le.  0)  then
      ic =  ic +  1
c      write(*,*) 'i', i, lchrom(i), ic
      else
c      write(*,*) 'i', i , lchrom(i), ic
       if(ic  .le.  mspan) then
       ifault  =  -2
       return
       else
       i1 = i1  + 1
       ik  =  i
       ic  =  1
c      write(*,*) 'i1,ik,ic', i1 , ik, ic
       endif
      endif
1     continue
      if(npd2 - ik + 1  .lt.  mspan)  then
      ifault  =  -2
      return
      endif
      if(i1  .gt.  nk - 1)  then
      ifault  =  -3
      return
      endif
      return
      end
      

        SUBROUTINE  RESID(Z , NDR, PA, NP, R, VFIT, SSQ, IEXIT, imodel)
        IMPLICIT REAL*8(A-H , O-Z)
        DIMENSION Z(NDR), PA(NP), R(NDR), VFIT(NDR)                             
      COMMON/THAR/ icri, nkp, k, k1, nd, rk(10), nnp(10), ppa(10,31)                                     
       data   tol / 8.43D-37 /                                          
       data     big  / 3.37D+38 /                                       
        IEXIT = 0
                                                                                
C      REAL ARRAY R IS SET TO ZERO                                      
                                                                        
        DO 1 I=1,NDR                                                    
1       R(I) = 0.0                                                      

C      PREDICTED TIME SERIES ACCORDING TO THE AUTOREGRESSIVE MODEL

         if(imodel .eq. 1)  then
        if(np .lt. 1)  goto 1402
        do  1401 i=1, np
1401    r(i)  =  z(i)
1402    continue
         np1 =  np + 1
        DO  1400  I  =  np1 ,  NDR
        DO  2400  J  =  1  ,  NP
2400    R(I) = R(I) + PA(J) * Z(I - J)
1400     CONTINUE
          endif

C      PREDICTED TIME SERIES ACCORDING TO THE STATE DEPENDENT EAR MODEL
 
         if(imodel .eq. 2)  then
         G  =  PA(NP)
         NQ1 = (NP - 1) / 2
        do  140 i=1, nq1
140     r(i)  =  z(i)
         nq2 =  nq1 + 1
        DO 100   I =  nq2 ,NDR
        DO  110  J  =  1 ,  NQ1
        J1  =  NQ1 + J
        C  =  PA(J) + PA(J1) * DEXP(-G * (Z(I - 1) ** 2))
        R(I) = R(I) +  C * Z(I - J)
       IF(DABS(R(I)) .LT. TOL) R(I) = 0.0
      IF(DABS(R(I)).GT.BIG) THEN
      IEXIT = -1
      RETURN
      ENDIF
110    CONTINUE
100     continue
          endif

C      PREDICTED TIME SERIES ACCORDING TO THE BILINEAR MODEL

         if(imodel .eq. 3)  then
        do  3401 i=1, np
3401    r(i)  =  z(i)
         np1 =  np + 1
        DO  3400  I  =  np1 ,  NDR
        R(I)  =  Z(I)
3400     CONTINUE
          endif

C      PREDICTED TIME SERIES ACCORDING TO THE THRESHOLD AR MODEL

        if(imodel .eq. 4)  then

C the first nq1=max(nd,p1,...,pk) predicted values equal the true values

       nq1 = nd
        do  441 i=1  ,  k
       if(nnp(i). gt. nq1) nq1 =  nnp(i)
441     continue
        do  440 i=1, nq1
440     r(i)  =  z(i)

C the nq1+1,...,ndr predicted values are computed from the TAR estimates

         nq2 =  nq1 + 1
      DO  400 I  =  nq2  ,  NDR

C       regime choice depends on Z(t - nd)

        jj =  i - nd
       do 411 iiii =  1 ,  k1
       if(z(jj) .lt. rk(iiii)) goto  414
411    continue
       iiii  =  k
414     continue

       ntp1  =  nnp(iiii)
       ntp  =  nnp(iiii) + 1
       do  412  j =1  ,  ntp
412    pa(j)  =  ppa(iiii ,  j)

C      the regime is k=iiii, the predicted value is inizialized to pa(0)

      R(I)  =  pa(1)
c       R(I)  =  0D0       
      DO  410  J  =  1  ,  Ntp1
      j1  =  j + 1
      R(I) =  R(I) + PA(J1) * Z(I - J)
410   CONTINUE
400   CONTINUE
         endif

C      RESIDUALS COMPUTATION: OBSERVED/SIMULATED TIME SERIES DATA Z 

        DO 101  I = 1 , NDR
        VFIT(I)  =   R(I)
101     R(I)  = Z(I) - R(I)

C      SUM OF SQUARES COMPUTATION

        SSQ  =  DOTPRD(NDR , R , R)
        RETURN                                                          
        END                                                             


       subroutine THCTRL(parver, NQ, icontr, imodel, XCOEFF, XROOTS)
        implicit real*8 (a-h, o-z)
      COMPLEX  XCOEFF(NQ+1), XROOTS(NQ)
      LOGICAL polish
        dimension parver(NQ)
      COMMON/THAR/ icri, np, k, k1, nd, r(10), nnp(10), ppa(10,31)                                     
      data  small/ 8.43D-37/
       lprint  =  6
      ONE =  1D0
c  check AR roots 1-p1B-p2B^2... all outside the unit circle
        if(imodel .eq. 1) then
        icontr  =  -1
      XCOEFF(1) =CMPLX(one)
      DO  1400  J  =  1  ,  NQ
      RCOEFF =  -parver(J)
      JJ  =  J + 1
      XCOEFF(JJ) =CMPLX(RCOEFF)
1400  continue
c      write(lprint, *) (xcoeff(j), j=1 , nq+1)
      polish=.false.
      call zroots(XCOEFF,NQ,XROOTS,polish)
c      write(lprint, *) (xroots(j), j=1 , nq)
      do  1015 i  =  1  ,  NQ
      xnorm = CABS(xroots(i))
c      write(lprint,'(1x,i4,4x, F10.4)') i, xnorm
      if(xnorm .le. one) goto  1409  
1015  continue
       icontr  =  0
1409   continue
        endif
c  check Haggan-Ozaki conditions (Biometrika, 1981)
        if(imodel .eq. 2) then
        icontr =  -1
       RCOEFF =  parver(NQ)
        if(RCOEFF. le. 0D0) goto  2409         
        nq1 = (nq - 1) / 2
        nq2 =  nq1 + 1
      XCOEFF(nq2) =CMPLX(one)
      DO  2400  J  =  1  ,  NQ1
      RCOEFF =  -parver(J)
      JJ  =  NQ1 - J + 1
      XCOEFF(JJ) =CMPLX(RCOEFF)
2400  continue
      write(LPRINT, *) (xcoeff(j), j=1 , nq2)
      polish=.false.
      call zroots(XCOEFF,NQ1,XROOTS,polish)
      write(LPRINT, *) (xroots(j), j=1 , nq1)
      do  2015 i  =  1  ,  NQ1
      xnorm = CABS(xroots(i))
      write(LPRINT,'(1x,i4,4x, F10.4)') i, xnorm
      if(xnorm .ge. one) goto  2409  
2015  continue
      XCOEFF(nq2) =CMPLX(one)
      DO  2401  J  =  1  ,  NQ1
      J1 = J + NQ1
      RCOEFF =  -(parver(J) + parver(J1))
      JJ  =  NQ1 - J + 1
      XCOEFF(JJ) =CMPLX(RCOEFF)
2401  continue
      write(LPRINT, *) (xcoeff(j), j=1 , nq2)
      polish=.false.
      call zroots(XCOEFF,NQ1,XROOTS,polish)
      write(LPRINT, *) (xroots(j), j=1 , nq1)
      inside  = 0
      do  2025 i  =  1  ,  NQ1
      xnorm = CABS(xroots(i))
      write(LPRINT,'(1x,i4,4x, F10.4)') i, xnorm
      if(xnorm .lt. one) inside = inside + 1  
2025  continue
c      pause
      if(inside .eq. nq1) goto 2409
      sum = 0D0
      DO  2402  J  =  1  ,  NQ1
2402  sum  =  sum +  parver(J)
      sam =  0D0
      DO  2403  J  =  1  ,  NQ1
      J1 = NQ1 + J
2403  sam  =  sam +  parver(J1)
      IF(DABS(SAM)  .LE. small)  goto  2409
      FF =  (1D0 - sum) / sam
      write(LPRINT, 100) sum, sam, FF
100   format(1h  ,'Sum phi = ', F10.4,2x, 'Sum pi = ', F10.4
     +, 2x, 'FF =', F10.4)
c      pause
      if(FF .ge. 0D0  .and. FF .le. 1D0) goto  2409
       icontr = 0 
2409   continue
         endif
c  check bilinear model patrameters
        if(imodel .eq. 3) then
       icontr = 0 
         endif
c  checks that the AR roots p0-p1B-p2B^2... of the k - regimes of the
c  TAR threshold models all lie outside the unit circle
        if(imodel .eq. 4) then
        icontr  =  -1
       do  4401  iiii  =  1 , k
        nq1 = nnp(iiii) 
        nq2 = nnp(iiii) + 1
      XCOEFF(1) =CMPLX(one)
      if(NQ2 .ge. 2)  then
      DO  4400  J  =  2  ,  NQ2
      RCOEFF =  -ppa(iiii , J)
      XCOEFF(J) =CMPLX(RCOEFF)
4400  continue
       endif
      write(lprint, *) (xcoeff(j), j=1 , nq2)
      polish=.false.
      call zroots(XCOEFF,NQ1,XROOTS,polish)
      write(lprint, *) (xroots(j), j=1 , nq1)
      do  4015 i  =  1  ,  NQ1
      xnorm = CABS(xroots(i))
      write(lprint,'(1x,i4,4x, F10.4)') i, xnorm
      if(xnorm .le. one) goto  4409  
4015  continue
4401  continue
       icontr  =  0
4409   continue
         endif
        return
         end


      SUBROUTINE zroots(a,m,roots,polish)
C     roots of a polynomial by Laguerre's method with deflation 
      INTEGER m,MAXM
      REAL EPS
      COMPLEX a(m+1),roots(m)
      LOGICAL polish
      PARAMETER (EPS=1.e-6,MAXM=101)
CU    USES laguer
      INTEGER i,j,jj,its
      COMPLEX ad(MAXM),x,b,c
      do 11 j=1,m+1
        ad(j)=a(j)
11    continue
      do 13 j=m,1,-1
        x=cmplx(0.,0.)
        call laguer(ad,j,x,its)
        if(abs(aimag(x)).le.2.*EPS**2*abs(real(x))) x=cmplx(real(x),0.)
        roots(j)=x
        b=ad(j+1)
        do 12 jj=j,1,-1
          c=ad(jj)
          ad(jj)=b

          b=x*b+c
12      continue
13    continue
      if (polish) then
        do 14 j=1,m
          call laguer(a,m,roots(j),its)
14      continue
      endif
      do 16 j=2,m
        x=roots(j)
        do 15 i=j-1,1,-1
          if(real(roots(i)).le.real(x))goto 10
          roots(i+1)=roots(i)
15      continue
        i=0
10      roots(i+1)=x
16    continue
      return
      END


      SUBROUTINE laguer(a,m,x,its)
C     roots of a polynomial by Laguerre's method  
      INTEGER m,its,MAXIT,MR,MT
      REAL EPSS
      COMPLEX a(m+1),x
      PARAMETER (EPSS=2.e-7,MR=8,MT=10,MAXIT=MT*MR)
      INTEGER iter,j
      REAL abx,abp,abm,err,frac(MR)
      COMPLEX dx,x1,b,d,f,g,h,sq,gp,gm,g2
      SAVE frac
      DATA frac /.5,.25,.75,.13,.38,.62,.88,1./
      do 12 iter=1,MAXIT
        its=iter
        b=a(m+1)
        err=abs(b)
        d=cmplx(0.,0.)
        f=cmplx(0.,0.)
        abx=abs(x)
        do 11 j=m,1,-1
          f=x*f+d

          d=x*d+b
          b=x*b+a(j)
          err=abs(b)+abx*err
11      continue
        err=EPSS*err
        if(abs(b).le.err) then
          return
        else
          g=d/b
          g2=g*g
          h=g2-2.*f/b
          sq=sqrt((m-1)*(m*h-g2))
          gp=g+sq
          gm=g-sq
          abp=abs(gp)
          abm=abs(gm)
          if(abp.lt.abm) gp=gm
          if (max(abp,abm).gt.0.) then
            dx=m/gp
          else
            dx=exp(cmplx(log(1.+abx),float(iter)))

          endif
        endif
        x1=x-dx
        if(x.eq.x1)return
        if (mod(iter,MT).ne.0) then
          x=x1
        else
          x=x-dx*frac(iter/MT)
        endif
12    continue
      pause 'too many iterations in laguer'
      return
      END


      SUBROUTINE GRADU(X,XX,XORD,N,NG,NUM)
      IMPLICIT REAL*8(A - H , O -Z)
      DIMENSION X(NUM),XX(NUM),XORD(NUM),N(NUM),NG(NUM)
          big  =   3.37D+38
      DO   1   I   =  1  , NUM
1     XX(I)   =    X(I)
       K   =    0
3     K  =   K   +   1
      AMIN   =   big
	 DO  2   I   =   1   ,   NUM
       IF(XX(I).GE.AMIN)    GOTO  2
      AMIN   =    XX(I)
       J   =   I
2     CONTINUE
      XORD(K)   =    XX(J)
      N(J)   =   K
      NG(K)   =   J
      XX(J)    =     big
      IF(K.LT.NUM)     GOTO  3
      RETURN
      END


      REAL*8 FUNCTION FFB(lchrom, nchro, nk, lprint, ifault)
      IMPLICIT REAL*8 (A - H , O - Z)
      DIMENSION LCHROM(NCHRO)
      COMMON/TSOBS/ NHB, Z(5500), KKHN(5500), ZO(5500), ZH(5500)
     +, NJ(10), XMAT(5500, 31)
     +, PHI(31), AUX1(31), VC1(31 , 31), BB(31), CC(31), IP(31), IQ(31)                                     
      COMMON/THAR/ icri, np, k, k1, nd, r(10), nnp(10), ppa(10,31)                                     
      data  tol/ 8.43D-37/
       data     big  / 3.37D+38 /                                       

      IFAULT  =  0

      IK  =  0
      DO  1   II  =  1  ,  NCHRO
      IF(LCHROM(II) .GE. 1) THEN
      IK = IK +  1
      NJ(IK) = II - 1
      JJ = KKHN(II)
      R(IK)  =  Z(JJ) 
      ENDIF
1     CONTINUE
      KJ =  IK +  1
      NJ(KJ)  =  NHB
      K1  =  IK
      K  =  IK  +  1

c      WRITE(LPRINT, 102)
c102   FORMAT(1H  ,'vettore lchrom')
c      WRITE(LPRINT, 103) (LCHROM(II), II=1,  NCHRO)
c103   FORMAT(1H   ,  70I1)
c      WRITE(LPRINT, 104)
c104   FORMAT(1H  ,'vettore nj')
c      WRITE(LPRINT, 105) (NJ(IK), IK=1,  KJ)
c105   FORMAT(1H   ,  15I5)
c      WRITE(LPRINT, 100) KJ
c100   FORMAT(1H  ,'regimi ', I5, 5X, 'obs:ini;fin')

c      I1  =  1
c      DO  2  II  =  1 ,  KJ
c      I2 =  NJ(II)
c
c      WRITE(LPRINT, 101) I1, I2
c101   FORMAT(1H   ,  2I10)
c
c      I1 =  I2 +  1
c2     CONTINUE        

      ckhrit =  0.0
      I1  =  1
      DO  3  II  =  1 ,  KJ
      I2 =  NJ(II)

C      set maximum order of the AR model for the ii-th regime

      mnp  =  np      
      criter =  big

C      Searching for nnp(ii) with AIC (icri=1) or BIC (icri=2)

      do  4917  nkp =  1  ,  mnp
      ik  =   0
      DO  4  I  =  I1 , I2
      J  =  KKHN(I) + ND
      if(j .lt. nkp + 1 .or. j. gt. nhb) goto  4

c      WRITE(LPRINT, 106) II, I, Z(J)
c106   FORMAT(1H  ,'regime ', i3, 3x, 'obs ', i5, 3x, 'z ', F10.4)

      ik  =  ik  +  1
      ZO(IK) =  Z(J)
      xmat(ik , 1)  =  1D0
      if(nkp .lt. 1)  goto  6
      do  5  lagh =  1 ,  nkp
      lag1  =  lagh  +  1
c       lag1  =  lagh
      jj  =  j - lagh
      if(jj  .ge.  1)  then
      xmat(ik , lag1)  =  z(jj)
      else
      xmat(ik, lag1)  =  0.0D-000 
      endif
5     continue
6     continue
4     continue

      nkp1  =  nkp  +  1

c      write(lprint,  108)
c108   format(1h  ,'ZO = matrice XMAT')
c      do  7  j =  1  ,  ik
c7     write(lprint, 107) ZO(j), (xmat(j , jj), jj = 1  ,  nkp1)
c107   format(1h  ,7F10.4) 

      CALL REGRES(ZO, XMAT, 5500, IK, PHI, NkP1, AUX1, VC1, 31, BB, CC
     +, IP, IQ, TOL, MSING)
c      CALL REGRES(ZO, XMAT, 5500, IK, PHI, NkP, AUX1, VC1, 31, BB, CC
c     +, IP, IQ, TOL, MSING)

      IF(MSING  .EQ.  2)  THEN
      IFAULT  =  -1
      RETURN
      ENDIF

      sskp =  0D0
      do  9  jj =  1  ,  ik
      zo1 =  0D0
      do  10  ij  =  1 , nkp1
10    zo1 = zo1 +  phi(ij) * xmat(jj, ij)
9      sskp =  sskp + (zo(jj) -  zo1) * (zo(jj) - zo1)
      if(icri  .eq.  1)  then
      crki =  dble(ik) * dlog(sskp / dble(ik)) + dble(nkp1) * 2D0 
      else
      crki= dble(ik) * dlog(sskp/dble(ik)) + dble(nkp1) * dlog(dble(ik))
      endif      

c      write(lprint , 119)  ii, np, nkp
c119   format(1h  ,'regime,np,nkp ', 3I6)
c      write(lprint, 117) (phi(jj),  jj=1 , nkp1)
c117 	format(1h  ,7F10.4)
c      write(lprint, 116) sskp, icri, crki
c116   format(1h  ,'sskp,icri,crki ', D14.6, i2, D14.6)      

      if(crki .lt. criter)  then
      criter  =   crki
      nnp(ii)  =  nkp
c      PPA(II, 1)  =  0D0
      IJ = 0
      DO  8  JJ  =  1  ,  NkP1
c      DO  8  JJ  =  2  ,  NkP1
      IJ = IJ + 1
8     PPA(II,  JJ)  =  PHI(IJ)
c8     PPA(II,  JJ)  =  PHI(IJ)
      endif

4917   continue

      ckhrit = ckhrit +  criter

      I1 =  I2 +  1
3     CONTINUE        

c      WRITE(LPRINT, 109) k
c109   FORMAT(1H  ,'risultati FFB, k = ',  I5)
c      do  12  ii  =  1  ,  k
c      write(lprint, 110) ii, r(ii), nnp(ii)
c110   format(1h   ,'regime,r,nnp ', I5, F12.4, I10)
c      nnp1 = nnp(ii)  +  1
c12     write(lprint, 111) (ppa(ii, jj),  jj=1 , nnp1)
c111 	format(1h  ,7F10.4)

      IMODEL  =  4
      np1  =  np + 1
      CALL  RESID(Z , NHB, PHI, NP1, ZO, ZH, SSQ, IEXIT, imodel)

c      write(lprint, 112) iexit
c112   format(1h  ,'exit RESID, iexit = ', I10)
c      write(lprint, 113)  ssq
c113   format(1h   ,'Residual sum of squares SSQ = ', D14.6)

      IF(IEXIT  .LT. 0) THEN
      IFAULT = -1
      RETURN
      ENDIF

	n0 =  max0(nd, mnp)
      crki  =  ckhrit / dble(nhb-n0)

c      p = 0D0
c      do  11  i  =  1  ,  k
c11    p  =  p  +  dble(nnp(i) + 1)
c      if(icri  .eq.  1)  then
c      crki =  dlog(ssq / dble(nhb)) + p * 2D0 / dble(nhb)
c      else
c      crki = dlog(ssq / dble(nhb)) + p * dlog(dble(nhb)) / dble(nhb)
c      endif      

      FFB  =  dexp(-crki)
      
c      IF(SSQ  .GT.  TOL) THEN
c      FFB  =  1D0 / SSQ
c      ELSE
c      FFB  =   0D0
c      ENDIF

c      write(lprint, 115) icri, p, crki 
c115   format(1h  ,'icri,p,crki ',  I2, 2D14.6)
c      write(lprint, 114) ffb
c114   format(1h   ,'Exit FFB = ', D14.6)

      RETURN

      END


      SUBROUTINE REGRES(Y, XMAT, MOB, NOB, P, NP, A, D, MP, B, C, IP, IQ
     +, EPS, MSING)

C   Linear regression ordinary least squares : p = (X'X)^(-1) X'y
C   msing = 1, normal exit; msing = 2, the matrix X'X is singular

      IMPLICIT REAL*8 (A - H , O - Z)
      DIMENSION  Y(NOB), XMAT(MOB, NP), P(NP), A(NP) 
     +, D(MP, NP), B(NP), C(NP), IP(NP), IQ(NP)

C   X'X -> D (here X == XMAT)

      DO  1  I  =1  ,  NP
      DO 1  J  =1  ,  NP
      SUM  =  0.0
      DO  2  K  =1  ,  NOB
2     SUM  =  SUM  +  XMAT(K , I) * XMAT(K , J)
1     D(I , J)  =  SUM

C   (X'X)^(-1) -> D

      CALL  DGJR(D, NP, MP, EPS, MSING, B, C, IP, IQ)
      IF(MSING .EQ. 2)  RETURN

C   X'y -> a

      DO  3  I  =1  ,  NP
      SUM  =  0.0
      DO  4  K  =1  ,  NOB
4     SUM =  SUM + XMAT(K , I) * Y(K)
3     A(I)  =  SUM

C   (X'X)^(-1) X'y == Da -> p

      DO  5  I =1  ,  NP
      SUM  =  0.0
      DO  6  J  =1  ,  NP
6     SUM  =  SUM +  D(I , J) * A(J)
5     P(I) =  SUM
C                                                             End REGRES
      RETURN
      END


      SUBROUTINE DGJR(A,N,MM,EPS,MSING,B,C,P,Q)
C----     GAUSS-JORDAN-RUTISHAUSER MATRIX INVERSION WITH DOUBLE PIVOTING
      IMPLICIT REAL*8 (A - H , O - Z)
      INTEGER P,Q
      DIMENSION A(MM,N),B(N),C(N),P(N),Q(N)
      MSING=1
      DO 10 K=1,N
C----     DETERMINATION OF THE PIVOT ELEMENT
      PIVOT=0.0
      DO 20 I=K,N
      DO 20 J=K,N
      IF(DABS(A(I,J))-DABS(PIVOT)) 20,20,30
30    PIVOT=A(I,J)
      P(K)=I
      Q(K)=J
20    CONTINUE
      IF(DABS(PIVOT)-EPS) 40,40,50
C----     EXCHANGE OF THE PIVOTAL ROW WITH THE K-TH ROW
50    IF(P(K)-K) 60,80,60
60    DO 70 J=1,N
      L=P(K)
      Z=A(L,J)
      A(L,J)=A(K,J)
70    A(K,J)=Z
C----     EXCHANGE OF THE PIVOTAL COLUMN WITH THE K-TH COLUMN
80    IF(Q(K)-K) 85,90,85
85    DO 100 I=1,N
      L=Q(K)
      Z=A(I,L)
      A(I,L)=A(I,K)
100   A(I,K)=Z
90    CONTINUE
C----     JORDAN STEP
      DO 110 J=1,N
      IF(J-K) 130,120,130
120   B(J)=1.0/PIVOT
      C(J)=1.0
      GOTO 140
130   B(J)=-A(K,J)/PIVOT
      C(J)=A(J,K)
140   A(K,J)=0.0
110   A(J,K)=0.0
      DO 10 I=1,N
      DO 10 J=1,N
10    A(I,J)=A(I,J)+C(I)*B(J)
C----     REORDERING THE MATRIX
      DO 155 M=1,N
      K=N-M+1
      IF(P(K)-K) 160,170,160
160   DO 180 I=1,N
      L=P(K)
      Z=A(I,L)
      A(I,L)=A(I,K)
180   A(I,K)=Z
170   IF(Q(K)-K) 190,155,190
190   DO 150 J=1,N
      L=Q(K)
      Z=A(L,J)
      A(L,J)=A(K,J)
150   A(K,J)=Z
155   CONTINUE
151   RETURN
40    CONTINUE
      MSING=2
      GOTO 151
      END
                                                                       

      REAL*8 FUNCTION DOTPRD(P, X, Y)                                   ARI03050
C                                                                       ARI03060
C  ***  RETURN THE INNER PRODUCT OF THE P-VECTORS X AND Y.  ***         ARI03070
C                                                                       ARI03080
C                                                                       ARI03090
C     THIS PROGRAM IS TAKEN FROM :                                      ARI03100
C     J.E.DENNIS, D.M.GAY AND R.E.WELSCH, 'ALGORITHM 573 NL2SOL-        ARI03110
C     AN ADAPTIVE NONLINEAR LEAST-SQUARES ALGORITHM E4| ',             ARI03120
C     ACM TRANSECTIONS ON MATHEMATICAL SOFTWARE, VOL.7, NO.3,           ARI03130
C     SEPTEMBER 1981                                                    ARI03140
C                                                                       ARI03150
      INTEGER P                                                         ARI03160
      REAL*8 X(P), Y(P)                                                 ARI03170
C                                                                       ARI03180
      INTEGER I                                                         ARI03190
      REAL ONE, SQTETA, T, ZERO                                         ARI03200
C/+                                                                     ARI03210
      REAL*8 DMAX1, DABS                                                ARI03220
      REAL  ABS
C/                                                                      ARI03230
      EXTERNAL RMDCON                                                   ARI03240
      REAL RMDCON                                                       ARI03250
C                                                                       ARI03260
C  ***  RMDCON(2) RETURNS A MACHINE-DEPENDENT CONSTANT, SQTETA, WHICH   ARI03270
C  ***  IS SLIGHTLY LARGER THAN THE SMALLEST POSITIVE NUMBER THAT       ARI03280
C  ***  CAN BE SQUARED WITHOUT UNDERFLOWING.                            ARI03290
C                                                                       ARI03300
C/6                                                                     ARI03310
      DATA ONE/1.E+0/, SQTETA/0.E+0/, ZERO/0.E+0/                       ARI03320
C/7                                                                     ARI03330
C     PARAMETER (ONE=1.D+0, ZERO=0.D+0)                                 ARI03340
C     DATA SQTETA/0.D+0/                                                ARI03350
C/                                                                      ARI03360
C                                                                       ARI03370
      DOTPRD = ZERO                                                     ARI03380
      IF (P .LE. 0) GO TO 999                                           ARI03390
      IF (SQTETA .EQ. ZERO) SQTETA = RMDCON(2)                          ARI03400
      DO 20 I = 1, P                                                    ARI03410
         T = DMAX1(DABS(X(I)), DABS(Y(I)))                              ARI03420
         IF (T .GT. ONE) GO TO 10                                       ARI03430
         IF (T .LT. SQTETA) GO TO 20                                    ARI03440
         T = (X(I)/SQTETA)*Y(I)                                         ARI03450
         IF (ABS(T) .LT. SQTETA) GO TO 20                               ARI03460
 10      DOTPRD = DOTPRD + X(I)*Y(I)                                    ARI03470
 20   CONTINUE                                                          ARI03480
C                                                                       ARI03490
 999  RETURN                                                            ARI03500
C  ***  LAST CARD OF DOTPRD FOLLOWS  ***                                ARI03510
      END                                                               ARI03520


      REAL FUNCTION RMDCON(K)                                           ARI14080
                                                                        ARI14090
C  ***  RETURN MACHINE DEPENDENT CONSTANTS                 ***          ARI14100
C                                                                       ARI14110
C     THIS PROGRAM IS TAKEN FROM :                                      ARI14120
C     J.E.DENNIS, D.M.GAY AND R.E.WELSCH, 'ALGORITHM 573 NL2SOL-        ARI14130
C     AN ADAPTIVE NONLINEAR LEAST-SQUARES ALGORITHM E4| ',             ARI14140
C     ACM TRANSECTIONS ON MATHEMATICAL SOFTWARE, VOL.7, NO.3,           ARI14150
C     SEPTEMBER 1981                                                    ARI14160
C                                                                       ARI14170
C +++  COMMENTS BELOW CONTAIN DATA STATEMENTS FOR VARIOUS MACHINES.  +++ARI14180
C +++  TO CONVERT TO ANOTHER MACHINE, PLACE A C IN COLUMN 1 OF THE   +++ARI14190
C +++  DATA STATEMENT LINE(S) THAT CORRESPOND TO THE CURRENT MACHINE +++ARI14200
C +++  AND REMOVE THE C FROM COLUMN 1 OF THE DATA STATEMENT LINE(S)  +++ARI14210
C +++  THAT CORRESPOND TO THE NEW MACHINE.                           +++ARI14220
C                                                                       ARI14230
      INTEGER K                                                         ARI14240
C                                                                       ARI14250
C  ***  THE CONSTANT RETURNED DEPENDS ON K...                           ARI14260
C                                                                       ARI14270
C  ***        K = 1... SMALLEST POS. ETA SUCH THAT -ETA EXISTS.         ARI14280
C  ***        K = 2... SQUARE ROOT OF 1.001*ETA.                        ARI14290
C  ***        K = 3... UNIT ROUNDOFF = SMALLEST POS. NO. MACHEP SUCH    ARI14300
C  ***                 THAT 1 + MACHEP .GT. 1 .AND. 1 - MACHEP .LT. 1.  ARI14310
C  ***        K = 4... SQUARE ROOT OF 0.999*MACHEP.                     ARI14320
C  ***        K = 5... SQUARE ROOT OF 0.999*BIG (SEE K = 6).            ARI14330
C  ***        K = 6... LARGEST MACHINE NO. BIG SUCH THAT -BIG EXISTS.   ARI14340
C                                                                       ARI14350
      REAL BIG, ETA, MACHEP                                             ARI14360
                                                                        ARI14370
      REAL SQRT                                                         ARI14380
                                                                        ARI14390
      REAL ONE001, PT999                                                ARI14400
                                                                        ARI14410
      DATA ONE001/1.001/, PT999/0.999/                                  ARI14420
                                                                        ARI14430
C  +++  IBM 360, IBM 370, OR XEROX  +++                                 ARI14440
C                                                                       ARI14450
C      DATA BIG/Z7FFFFFFF/, ETA/Z00100000/, MACHEP/Z3C100000/           ARI14460
C                                                                       ARI14470
C  +++  DATA GENERAL  +++                                               ARI14480
C                                                                       ARI14490
C     DATA BIG/0.7237E+76/, ETA/0.5398E-78/, MACHEP/0.9537E-06/         ARI14500
C                                                                       ARI14510
C  +++  DEC 11  +++                                                     ARI14520
C                                                                       ARI14530
C     DATA BIG/1.7E+38/, ETA/2.9388E-39/, MACHEP/1.1921E-07/            ARI14540
C                                                                       ARI14550
C  +++  HP3000  +++                                                     ARI14560
C                                                                       ARI14570
C     DATA BIG/1.1579E+77/, ETA/8.6362E-78/, MACHEP/2.3842E-07/         ARI14580
C                                                                       ARI14590
C  +++  HONEYWELL  +++                                                  ARI14600
C                                                                       ARI14610
C     DATA BIG/O376777000000/, ETA/O404400400000/,                      ARI14620
C    1     MACHEP/O716400000000/                                        ARI14630
C                                                                       ARI14640
C  +++  DEC10  +++                                                      ARI14650
C                                                                       ARI14660
C     DATA BIG/"377777777777/, ETA/"000400000021/,                      ARI14670
C    1     MACHEP/"147400000000/                                        ARI14680
C                                                                       ARI14690
C  +++  BURROUGHS  +++                                                  ARI14700
C                                                                       ARI14710
C     DATA BIG/O0777777777777777/, ETA/O1771000000000000/,              ARI14720
C    1     MACHEP/O1301000000000000/                                    ARI14730
C                                                                       ARI14740
C  +++  CONTROL DATA  +++                                               ARI14750
C                                                                       ARI14760
C     DATA BIG/37754000000000000000B/, ETA/00024000000000000000B/,      ARI14770
C    1     MACHEP/16414000000000000000B/                                ARI14780
C                                                                       ARI14790
C  +++  PRIME  +++                                                      ARI14800
C                                                                       ARI14810
C     DATA BIG/1.7E+38/, ETA/1.47E-39/, MACHEP/2.38419E-7/              ARI14820
C                                                                       ARI14830
C  +++  UNIVAC  +++                                                     ARI14840
C                                                                       ARI14850
C     DATA BIG/1.69E+38/, ETA/5.9E-39/, MACHEP/1.4901162E-8/            ARI14860
C                                                                       ARI14870
C  +++  VAX  +++                                                        ARI14880
C                                                                       ARI14890
C     DATA BIG/1.7E+38/, ETA/2.939E-39/, MACHEP/5.9604645E-08/          ARI14900
C
c  approximations of real numbers in floating-point form (1 to 7 digits)        
c  from 8.43E-37 to 3.37E+38 (assumed zero if less/equal than 0.000015)
        big  =  3.37E+38
        eta  =   8.43E-37 
        machep  = 0.000015 
C                                                                       ARI14910
C-------------------------------  BODY  --------------------------------ARI14920
                                                                        ARI14930
      GO TO (10, 20, 30, 40, 50, 60), K                                 ARI14940
                                                                        ARI14950
 10   RMDCON = ETA                                                      ARI14960
      GO TO 999                                                         ARI14970
                                                                        ARI14980
 20   RMDCON = SQRT(ONE001*ETA)                                         ARI14990
      GO TO 999                                                         ARI15000
                                                                        ARI15010
 30   RMDCON = MACHEP                                                   ARI15020
      GO TO 999                                                         ARI15030
                                                                        ARI15040
 40   RMDCON = SQRT(PT999*MACHEP)                                       ARI15050
      GO TO 999                                                         ARI15060
                                                                        ARI15070
 50   RMDCON = SQRT(PT999*BIG)                                          ARI15080
      GO TO 999                                                         ARI15090
                                                                        ARI15100
 60   RMDCON = BIG                                                      ARI15110
                                                                        ARI15120
 999  RETURN                                                            ARI15130
C  ***  LAST CARD OF RMDCON FOLLOWS  ***                                ARI15140
      END                                                               ARI15150
                                                                        ARI15160

      REAL*8 FUNCTION SUMF(X,N)
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION X(N)                                                    
      SUMF=0.0                                                          
      DO 10 I=1,N                                                       
   10 SUMF=SUMF+X(I)                                                    
      RETURN                                                            
      END                                                               


      REAL*8 FUNCTION RMEAN(X,NOB)                                      ARI01510
C                                                                       ARI01520
C----      DOUBLE PRECISION FUNCTION RMEAN                              ARI01530
C                                                                       ARI01540
C      CALCULATES THE SAMPLE MEAN OF A SERIES OF NOB OBSERVATIONS       ARI01550
C                                                                       ARI01560
C----                                                                   ARI01570
C                                                                       ARI01580
C      THIS PROGRAM IS TAKEN FROM " A COMPUTER PROGRAM FOR THE          ARI01590
C      ANALYSIS OF TIME SERIES MODELS USING THE BOX-JENKINS PHILOSOPHY "ARI01600
C      BY D.J.PACK (1979) AUTOMATIC FORECASTING SYSTEMS, INC.           ARI01610
C                                                                       ARI01620
C----                                                                   ARI01630
C                                                                       ARI01640
C      X:  OBSERVED TIME SERIES OF NOB VALUES                           ARI01650
C                                                                       ARI01660
C----                                                                   ARI01670
C                                                                       ARI01680
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION X(NOB)                                                  ARI01690
      SUM=0                                                             ARI01700
      DO 10 J=1,NOB                                                     ARI01710
  10  SUM=SUM+X(J)                                                      ARI01720
      RMEAN=SUM/FLOAT(NOB)                                              ARI01730
      RETURN                                                            ARI01740
      END                                                               ARI01750


      REAL*8 FUNCTION CPROXY(X,XBAR,Y,YBAR,NOB)                         ARI01760
C                                                                       ARI01770
C----     DOUBLE PRECISION FUNCTION CPROXY                              ARI01780
C                                                                       ARI01790
C      CALCULATES SUM OF PRODUCTS OF DEVIATIONS OF TWO VARIABLES        ARI01800
C      FROM SPECIFIED CENTRAL VALUES                                    ARI01810
C                                                                       ARI01820
C----                                                                   ARI01830
C                                                                       ARI01840
C      THIS PROGRAM IS TAKEN FROM " A COMPUTER PROGRAM FOR THE          ARI01850
C      ANALYSIS OF TIME SERIES MODELS USING THE BOX-JENKINS PHILOSOPHY "ARI01860
C      BY D.J.PACK (1979) AUTOMATIC FORECASTING SYSTEMS, INC.           ARI01870
C                                                                       ARI01880
C----                                                                   ARI01890
C                                                                       ARI01900
C      X,Y:      REAL ARRAYS OF LENGTH NOB.                             ARI01910
C                ON ENTRY CONTAIN VALUES OF THE TWO VARIABLES           ARI01920
C      XBAR,YBAR:X'S AND Y'S MEAN RESPECTIVELY                          ARI01930
C                                                                       ARI01940
C----                                                                   ARI01950
C                                                                       ARI01960
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION X(NOB),Y(NOB)                                           ARI01970
      S=0                                                               ARI01980
      DO 10 I=1,NOB                                                     ARI01990
  10  S=S+(X(I)-XBAR)*(Y(I)-YBAR)                                       ARI02000
      CPROXY=S                                                          ARI02010
      RETURN                                                            ARI02020
      END                                                               ARI02030


      SUBROUTINE ZCOR(C,NOB,NAC,R,SER,DM,DSD,IEXIT)                     ARI02040
C                                                                       ARI02050
C-----     SUBROUTINE ZCOR                                              ARI02060
C                                                                       ARI02070
C     CALCULATES AUTOCORRELATIONS AND THEIR STANDARD ERRORS             ARI02080
C                                                                       ARI02090
C-----                                                                  ARI02100
C                                                                       ARI02110
C     C     SERIES INPUT OF NOB OBS.                                    ARI02120
C     NAC   MAXIMUM LAG                                                 ARI02130
C     R     AUTOCORRELATION FUNCTION OF NAC VALUES                      ARI02140
C     SER  AUTOCOVARIANCE FUNCTION OF NAC VALUES                        ARI02150
C     DM    MEAN OF THE SERIES                                          ARI02160
C     DSD   STANDARD ERROR OF THE SERIES                                ARI02170
C     IEXIT IF NAC>= NOB IEXIT IS SET TO -1                             ARI02180
C           UNLESS THIS ONE ERROR IS DETECTED IEXIT                     ARI02190
C           CONTAINS ZERO ON EXIT                                       ARI02200
C                                                                       ARI02210
C-----                                                                  ARI02220
C                                                                       ARI02230
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION C(NOB),R(NAC),SER(NAC)                                  ARI02240
      IEXIT=0                                                           ARI02250
      IF(NOB-NAC) 100,100,20                                            ARI02260
   20 DIV=NOB                                                           ARI02270
      DM=RMEAN(C,NOB)                                                   ARI02280
      DENOM=CPROXY(C,DM,C,DM,NOB)                                       ARI02290
      DSD=DSQRT(DENOM/DIV)                                              ARI02300
      DO 30 K=1,NAC                                                     ARI02310
      M=NOB-K                                                           ARI02320
      HNUM=CPROXY(C(1),DM,C(K+1),DM,M)                                  ARI02330
      SER(K)=HNUM/DIV                                                   ARI02340
      R(K)=HNUM/DENOM                                                   ARI02350
   30 CONTINUE                                                          ARI02360
      NAC1=NAC+1                                                        ARI02370
      DO 40 K=1,NAC                                                     ARI02380
      M=NAC1-K+1                                                        ARI02390
      R(M)=R(M-1)                                                       ARI02400
      SER(M)=SER(M-1)                                                   ARI02410
   40 CONTINUE                                                          ARI02420
      R(1)=1.0                                                          ARI02430
      SER(1)=DSD*DSD                                                    ARI02440
      RETURN                                                            ARI02450
  100 IEXIT=-1                                                          ARI02460
      RETURN                                                            ARI02470
      END                                                               ARI02480


      SUBROUTINE VSUNIF(ISEME,P2)
      IMPLICIT INTEGER*4 (I-N)
      REAL*8 CC0,CC1,CC2,CC3,CC4,P2
      DATA CC2/16807.D0/,CC3/2147483647.D0/
      SAVE
      CC1=ISEME
      CC1=CC1*CC2
      CC4=DMOD(CC1,CC3)
      ISEME=CC4
      CC0=CC4
      P2=CC0/CC3
      RETURN
      END


